// Code generated by go-swagger; DO NOT EDIT.

package avatar_candidate

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// NewAvatarCandidateCreateParams creates a new AvatarCandidateCreateParams object
// with the default values initialized.
func NewAvatarCandidateCreateParams() *AvatarCandidateCreateParams {
	var ()
	return &AvatarCandidateCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewAvatarCandidateCreateParamsWithTimeout creates a new AvatarCandidateCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewAvatarCandidateCreateParamsWithTimeout(timeout time.Duration) *AvatarCandidateCreateParams {
	var ()
	return &AvatarCandidateCreateParams{

		timeout: timeout,
	}
}

// NewAvatarCandidateCreateParamsWithContext creates a new AvatarCandidateCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewAvatarCandidateCreateParamsWithContext(ctx context.Context) *AvatarCandidateCreateParams {
	var ()
	return &AvatarCandidateCreateParams{

		Context: ctx,
	}
}

// NewAvatarCandidateCreateParamsWithHTTPClient creates a new AvatarCandidateCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewAvatarCandidateCreateParamsWithHTTPClient(client *http.Client) *AvatarCandidateCreateParams {
	var ()
	return &AvatarCandidateCreateParams{
		HTTPClient: client,
	}
}

/*AvatarCandidateCreateParams contains all the parameters to send to the API endpoint
for the avatar candidate create operation typically these are written to a http.Request
*/
type AvatarCandidateCreateParams struct {

	/*AppSlug
	  App slug

	*/
	AppSlug string
	/*AvatarCandidate
	  Avatar candidate parameters

	*/
	AvatarCandidate models.V0AvatarCandidateCreateBulkParams

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the avatar candidate create params
func (o *AvatarCandidateCreateParams) WithTimeout(timeout time.Duration) *AvatarCandidateCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the avatar candidate create params
func (o *AvatarCandidateCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the avatar candidate create params
func (o *AvatarCandidateCreateParams) WithContext(ctx context.Context) *AvatarCandidateCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the avatar candidate create params
func (o *AvatarCandidateCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the avatar candidate create params
func (o *AvatarCandidateCreateParams) WithHTTPClient(client *http.Client) *AvatarCandidateCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the avatar candidate create params
func (o *AvatarCandidateCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppSlug adds the appSlug to the avatar candidate create params
func (o *AvatarCandidateCreateParams) WithAppSlug(appSlug string) *AvatarCandidateCreateParams {
	o.SetAppSlug(appSlug)
	return o
}

// SetAppSlug adds the appSlug to the avatar candidate create params
func (o *AvatarCandidateCreateParams) SetAppSlug(appSlug string) {
	o.AppSlug = appSlug
}

// WithAvatarCandidate adds the avatarCandidate to the avatar candidate create params
func (o *AvatarCandidateCreateParams) WithAvatarCandidate(avatarCandidate models.V0AvatarCandidateCreateBulkParams) *AvatarCandidateCreateParams {
	o.SetAvatarCandidate(avatarCandidate)
	return o
}

// SetAvatarCandidate adds the avatarCandidate to the avatar candidate create params
func (o *AvatarCandidateCreateParams) SetAvatarCandidate(avatarCandidate models.V0AvatarCandidateCreateBulkParams) {
	o.AvatarCandidate = avatarCandidate
}

// WriteToRequest writes these params to a swagger request
func (o *AvatarCandidateCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app-slug
	if err := r.SetPathParam("app-slug", o.AppSlug); err != nil {
		return err
	}

	if o.AvatarCandidate != nil {
		if err := r.SetBodyParam(o.AvatarCandidate); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
